/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package forms;

import dao.FuncionarioDao;
import java.util.ArrayList;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;
import model.Funcionario;

/**
 *
 * @author pedroh
 */
public class FormBuscaFuncionario extends javax.swing.JFrame {
    
    DefaultTableModel modelo;

    /**
     * Creates new form FormBuscaCliente
     */
    public FormBuscaFuncionario() {
        initComponents();
        modelo = (DefaultTableModel) jtFuncionario.getModel();
        btExcluir.setEnabled(false);
        btEditar.setEnabled(false);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        tfNome = new javax.swing.JTextField();
        btBuscar = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jtFuncionario = new javax.swing.JTable();
        btEditar = new javax.swing.JButton();
        btExcluir = new javax.swing.JButton();
        btCancelar = new javax.swing.JButton();
        cbTodos = new javax.swing.JCheckBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Busca de Funcionario");
        setResizable(false);

        jLabel1.setText("Nome:");

        btBuscar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/system-search-3.png"))); // NOI18N
        btBuscar.setText("Buscar");
        btBuscar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btBuscarActionPerformed(evt);
            }
        });

        jtFuncionario.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "CPF", "Nome", "Cargo"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(jtFuncionario);
        if (jtFuncionario.getColumnModel().getColumnCount() > 0) {
            jtFuncionario.getColumnModel().getColumn(0).setResizable(false);
            jtFuncionario.getColumnModel().getColumn(0).setPreferredWidth(50);
            jtFuncionario.getColumnModel().getColumn(1).setResizable(false);
            jtFuncionario.getColumnModel().getColumn(1).setPreferredWidth(200);
            jtFuncionario.getColumnModel().getColumn(2).setResizable(false);
        }

        btEditar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/edit-4.png"))); // NOI18N
        btEditar.setText("Editar");
        btEditar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btEditarActionPerformed(evt);
            }
        });

        btExcluir.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/edit-delete-2.png"))); // NOI18N
        btExcluir.setText("Excluir");
        btExcluir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btExcluirActionPerformed(evt);
            }
        });

        btCancelar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/dialog-cancel-3.png"))); // NOI18N
        btCancelar.setText("Cancelar");
        btCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btCancelarActionPerformed(evt);
            }
        });

        cbTodos.setText("Todos");
        cbTodos.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbTodosActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(tfNome, javax.swing.GroupLayout.PREFERRED_SIZE, 295, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(btBuscar)
                        .addGap(18, 18, 18)
                        .addComponent(cbTodos)
                        .addGap(0, 12, Short.MAX_VALUE))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING))
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addGap(129, 129, 129)
                .addComponent(btEditar)
                .addGap(50, 50, 50)
                .addComponent(btExcluir)
                .addGap(45, 45, 45)
                .addComponent(btCancelar)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(tfNome, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btBuscar)
                    .addComponent(cbTodos))
                .addGap(18, 18, 18)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 288, Short.MAX_VALUE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btEditar)
                    .addComponent(btExcluir)
                    .addComponent(btCancelar))
                .addContainerGap())
        );

        setSize(new java.awt.Dimension(595, 462));
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void btBuscarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btBuscarActionPerformed
        limparGUI();
        
        
        if(tfNome.getText().equals("") && !cbTodos.isSelected()){
            JOptionPane.showMessageDialog(null, "Campo 'Nome' está vazio!","Nenhum nome",JOptionPane.WARNING_MESSAGE);
            return;
        }
        
        ArrayList<Funcionario> funcionarios;
        try {
            if(cbTodos.isSelected())
                funcionarios = (ArrayList<Funcionario>) (new FuncionarioDao()).todosFuncionarios();
            else
                funcionarios = (ArrayList<Funcionario>) (new FuncionarioDao()).buscarFuncionariosNome(tfNome.getText());
        } catch (NullPointerException e) {
            JOptionPane.showMessageDialog(null,"Não foi possível se conectar a base de dados","Erro busca",JOptionPane.ERROR_MESSAGE);
            return;
        }catch (Exception e) {
            JOptionPane.showMessageDialog(null,e,"Erro busca",JOptionPane.ERROR_MESSAGE);
            return;
        }
        
        if(funcionarios.isEmpty()){
            JOptionPane.showMessageDialog(null, "Nenhum Funcionário com este nome foi encontrado","Nome não encontrado",JOptionPane.INFORMATION_MESSAGE);
            return;
        }
        
        for(Funcionario f : funcionarios){
            modelo.addRow(new Object[]{
                f.getCpf(),
                f.getNome(),
                f.getCargo()
            });
        }
        
        btEditar.setEnabled(true);
        btExcluir.setEnabled(true);
    }//GEN-LAST:event_btBuscarActionPerformed
    
    private void btCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btCancelarActionPerformed
        this.dispose();
    }//GEN-LAST:event_btCancelarActionPerformed

    private void btEditarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btEditarActionPerformed
        int linhaSelecionada = jtFuncionario.getSelectedRow();
        if(linhaSelecionada == -1){
            JOptionPane.showMessageDialog(null, "Nenhum Funcionário selecionado!","Selecione o Funcionario",JOptionPane.INFORMATION_MESSAGE);
            return;
        }
        
        try{
            FuncionarioDao fdao = new FuncionarioDao();
            Funcionario funcionario = fdao.procurarFuncionario((String) modelo.getValueAt(linhaSelecionada, 0));
            (new FormFuncionario(funcionario)).setVisible(true);
        }catch(Exception e){
            JOptionPane.showMessageDialog(null, e,"Erro",JOptionPane.ERROR_MESSAGE);
        }
        limparGUI();
    }//GEN-LAST:event_btEditarActionPerformed

    private void btExcluirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btExcluirActionPerformed
        int linhaSelecionada = jtFuncionario.getSelectedRow();
        if(linhaSelecionada == -1){
            JOptionPane.showMessageDialog(null, "Nenhum Funcionário selecionado!","Selecione o Funcionario",JOptionPane.INFORMATION_MESSAGE);
            return;
        }
        
        try{
            FuncionarioDao fdao = new FuncionarioDao();
            Funcionario funcionario = fdao.procurarFuncionario((String) modelo.getValueAt(linhaSelecionada, 0));
            fdao = new FuncionarioDao();
            fdao.excluir(funcionario);
        }catch(Exception e){
            JOptionPane.showMessageDialog(null, e,"Erro",JOptionPane.ERROR_MESSAGE);
        }
        limparGUI();
    }//GEN-LAST:event_btExcluirActionPerformed

    private void cbTodosActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbTodosActionPerformed
      
    }//GEN-LAST:event_cbTodosActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(FormBuscaFuncionario.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(FormBuscaFuncionario.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(FormBuscaFuncionario.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(FormBuscaFuncionario.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new FormBuscaFuncionario().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btBuscar;
    private javax.swing.JButton btCancelar;
    private javax.swing.JButton btEditar;
    private javax.swing.JButton btExcluir;
    private javax.swing.JCheckBox cbTodos;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jtFuncionario;
    private javax.swing.JTextField tfNome;
    // End of variables declaration//GEN-END:variables

    
    private void limparGUI(){
        for(int i = modelo.getRowCount()-1; i>=0;i--)
            modelo.removeRow(i);
        
        btEditar.setEnabled(false);
        btExcluir.setEnabled(false);
    }
}
